diff -urNb aodv-uu-0.7.2/packet_input.c maodv-umd-0.7.2/packet_input.c
--- aodv-uu-0.7.2/packet_input.c	Mon Jun  2 19:20:10 2003
+++ maodv-umd-0.7.2/packet_input.c	Fri Dec  5 17:42:32 2003
@@ -29,6 +29,18 @@
 #include <netinet/udp.h>
 #include <netinet/ip_icmp.h>
 
+/* SOCK_RAW refuses to cooperate... */
+#include <sys/socket.h>
+#include <features.h>    /* for the glibc version number */
+#if __GLIBC__ >= 2 && __GLIBC_MINOR >= 1
+#include <netpacket/packet.h>
+#include <net/ethernet.h>     /* the L2 protocols */
+#else
+#include <asm/types.h>
+#include <linux/if_packet.h>
+#include <linux/if_ether.h>   /* The L2 protocols */
+#endif
+
 #include "defs.h"
 #include "debug.h"
 #include "routing_table.h"
@@ -44,6 +56,12 @@
 #include "packet_queue.h"
 #include "packet_input.h"
 
+#ifdef MAODV
+#include "igmp.h"
+#include "multicast_routing_table.h"
+#include "multicast_packet_cache.h"
+#endif
+
 #define BUFSIZE 2048
 
 extern int internet_gw_mode, wait_on_reboot, optimized_hellos, llfeedback;
@@ -58,6 +76,24 @@
 /* Set this if you want lots of debug printouts: */
 /* #define DEBUG_PACKET */
 
+/* from 
+    "Internetworking with TCP/IP: Volume II"
+    Second Edition
+    Douglas E. Comer, David L. Stevens */
+static u_int16_t my_ip_csum( unsigned short *buf, int nshorts )
+{
+    u_int32_t sum;
+
+    for( sum = 0; nshorts > 0; nshorts-- ) {
+        sum += *buf++;
+    }
+
+    sum = ( sum >> 16 ) + ( sum & 0xffff );
+    sum += (sum >> 16 );
+    
+    return ~sum;
+} 
+
 #ifndef NS_PORT
 static void die(struct ipq_handle *h)
 {
@@ -104,11 +140,26 @@
 static void packet_input(int fd)
 #endif
 {
-    rt_table_t *fwd_rt, *rev_rt, *next_hop_rt, *expired_rt = NULL;
+    rt_table_t *fwd_rt = NULL, *rev_rt, *next_hop_rt, *expired_rt = NULL;
     u_int32_t dest_addr, src_addr;
     u_int8_t rreq_flags = 0;
     unsigned int ifindex;
     struct ip_data *ipd = NULL;
+#ifdef MAODV
+    /* This is to "hack" around the Linux UDP ip->id field which
+       remains zero unless you fragment a IP packet.  Not likely.
+
+       We just change the ip->id for each packet leaving
+       destined for a multicast address.  There is really no
+       other way to work this in Linux.  The source code states
+       that Linux was never intened to have a router + host for 
+       multicast IP. 
+
+       The ip-id is needed to cache multicast packets to avoid
+       flooding a multicast packet around the network for ttl
+       hops.  */
+    static u_int16_t staticid = 0;
+#endif
 
 #ifdef NS_PORT
     ifindex = NS_IFINDEX;	// Always use ns interface
@@ -164,10 +215,20 @@
 
     if (pkt->hook == 0)
 	dev_name = pkt->indev_name;
-    else if (pkt->hook == 3)
+    else if ((pkt->hook == 3) || (pkt->hook == 4))
 	dev_name = pkt->outdev_name;
-    else
+    else {
 	dev_name = NULL;
+    }
+
+    if (dev_name) {
+	ifindex = name2index(dev_name);
+	if (ifindex < 0) {
+	    DEBUG(LOG_ERR, 0, "name2index error!");
+	    ifindex = 0;
+	}
+    } else
+	ifindex = 0;
 
     /* We know from kaodv.c that this is an IP packet */
     ip = (struct iphdr *) pkt->payload;
@@ -200,28 +261,30 @@
 #endif
 
 	break;
+#ifdef MAODV
+    case IPPROTO_IGMP:
+        if(pkt->hook == 3) {
+            igmp_process((IGMP*)((char*)ip + (ip->ihl << 2)), ifindex);
+
+            /* drop the packet after processing */
+            status = ipq_set_verdict(h, pkt->packet_id, NF_DROP, 0, NULL);
+            if(status < 0)
+                die(h);
+            return;
+        }
+        break;
+#endif
     }
 
 #ifdef DEBUG_PACKET
     DEBUG(LOG_INFO, 0, "pkt to %s", ip_to_str(dest_addr));
 #endif
 
-    if (dev_name) {
-	ifindex = name2index(dev_name);
-	if (ifindex < 0) {
-	    DEBUG(LOG_ERR, 0, "name2index error!");
-	    return;
-	}
-    } else
-	ifindex = 0;
 #endif				/* NS_PORT */
 
     /* If the packet is not interesting we just let it go through... */
     if (dest_addr == AODV_BROADCAST ||
-	dest_addr == DEV_IFINDEX(ifindex).broadcast ||
-	((internet_gw_mode && this_host.gateway_mode)
-	 && ((dest_addr & DEV_IFINDEX(ifindex).netmask) !=
-	     DEV_IFINDEX(ifindex).broadcast))) {
+    	dest_addr == DEV_IFINDEX(ifindex).broadcast) {
 #ifdef NS_PORT
 	sendPacket(p, 0, 0.0);
 #else
@@ -230,8 +293,14 @@
     }
 
     /* Find the entry of the neighboring node and the destination  (if any). */
-    rev_rt = rt_table_find(src_addr);
     fwd_rt = rt_table_find(dest_addr);
+    /* If captured because of gateway mode, do not try to construct a
+     * reverse route. */
+    if((pkt->mark == 4) && (pkt->hook == 0)) {
+        rev_rt = NULL;
+    } else {
+        rev_rt = rt_table_find(src_addr);
+    }
 
     /* UPDATE TIMERS on active forward and reverse routes...  */
 
@@ -263,6 +332,155 @@
 	    rt_table_update_timeout(next_hop_rt, ACTIVE_ROUTE_TIMEOUT);
     }
 
+#ifdef MAODV
+    if(IN_MULTICAST(dest_addr)){
+        u_int8_t *pay;
+        u_int32_t size;
+        mrt_table_t *mrt=mrt_table_find(dest_addr);
+
+        if(mrt==NULL || (!mrt->is_router && DEV_IFINDEX(ifindex).ipaddr!=src_addr)){
+            /* we got a packet for which we have no entry */
+	    status = ipq_set_verdict(h, pkt->packet_id, NF_DROP, 0, NULL);
+	    if (status < 0)
+		die(h);
+            return;
+        }
+        /* note: this is like an else... note the return */
+
+        if ( (pkt->mark == 4) || this_host.gateway_mode) {
+            /* Gateway mode relays packets itself since it can't control the
+             * multicast routing tables.  */
+            if((!this_host.gateway_mode
+                        && src_addr == DEV_IFINDEX(ifindex).ipaddr)
+                    || (ip->id == 0)) {
+            /* from our LOCAL_OUT hook.  let's change the ip->id field */
+            staticid++;
+            ip->id = htons(staticid);
+
+            /* now recalculate the chksum... wahoo! */
+            /* CHECK: this could be more intelligent... */ 
+            ip->check = 0;
+            ip->check = my_ip_csum( (unsigned short *) ip, ip->ihl * 2 );
+            }
+        }
+
+        if(!mrt->is_router || mrt->is_broken ){
+            /* we have an invalid route, do discovery. */
+            size = pkt->data_len;
+            pay = (u_int8_t *) malloc( pkt->data_len );
+            if ( pay == NULL ) {
+                perror( "in packet_input for multicast local out buffer." );
+                exit( -1 );
+            }
+            memcpy( pay, pkt->payload, size );
+
+            rreq_flags = rreq_flags | RREQ_JOIN;
+            mcast_packet_queue_add(pkt->packet_id, dest_addr, size, pay);
+
+            check_duplicate( src_addr, ip->id, pkt->hook );
+
+            goto mcast_route_discovery;
+
+        }else{
+            /* route is valid, packet wants out, send the packet along its
+             * way */
+            if ( !check_duplicate( src_addr, ip->id, pkt->hook ) ) {
+                status = ipq_set_verdict(h, pkt->packet_id, NF_DROP, 0, NULL);
+                if (status < 0)
+                    die(h);
+                return;  
+            } else {
+                mrt_sources_add( src_addr, dest_addr );
+                mrt_table_update_timeout(mrt, ACTIVE_ROUTE_TIMEOUT);
+
+                /* In gateway mode, we need to duplicate the packet ourselves
+                 * since OSPF is handling the route table and we can't ask it
+                 * to duplicate on this interface. */
+                if(this_host.gateway_mode && (pkt->hook == 0) && (ip->ttl > 1)
+                        && (src_addr != DEV_IFINDEX(ifindex).ipaddr)) {
+                    /* The injection of raw ip packets when a multicast route
+                     * exists for the destination appears broken.  This is a
+                     * workaround until a better solution can be found. */
+#if 1
+                    int sock = socket(PF_PACKET, SOCK_DGRAM, htonl(ETH_P_IP));
+                    struct sockaddr_ll sll;
+
+                    /* Decrement TTL, since the raw socket will recalculate
+                     * the IP checksum, don't worry about it */
+                    ip->ttl--;
+                    ip->check = 0;
+                    ip->check = my_ip_csum((unsigned short *) ip, ip->ihl * 2);
+
+                    /* Repeat packet */
+                    memset(&sll, 0, sizeof(sll));
+                    sll.sll_family = AF_PACKET;
+                    sll.sll_addr[0] = 1;
+                    sll.sll_addr[1] = 0;
+                    sll.sll_addr[2] = 0x5E;
+                    sll.sll_addr[3] = (dest_addr >> 16) & 0x7F;
+                    sll.sll_addr[4] = (dest_addr >> 8) & 0xFF;
+                    sll.sll_addr[5] = (dest_addr & 0xFF);
+                    sll.sll_halen = 6;
+                    sll.sll_ifindex = ifindex;
+                    sll.sll_protocol = htons(ETH_P_IP);
+                    if(sendto(sock, pkt->payload, pkt->data_len, 0,
+                                (struct sockaddr*)&sll, sizeof(sll)) < 0) {
+                        printf("ifindex = %d, devname = %s\n", ifindex, dev_name);
+                        perror("send_raw");
+                    }
+
+                    /* Reincrement the checksum so we don't have a bad
+                     * checksum or drop the packet. */
+                    ip->ttl++;
+                    ip->check = 0;
+                    ip->check = my_ip_csum((unsigned short *) ip, ip->ihl * 2);
+                    close(sock);
+#else /* #if 0 */
+                    /* This was an attempt at using the raw IP facilities to
+                     * repeat the IP packets.  Somewhere in the Linux IP
+                     * stack it was improperly clobbering the source IP.  This
+                     * only occured when a route for the multicast group
+                     * appeared in the multicast routing table. */
+                    int sock = socket(PF_INET, SOCK_RAW, IPPROTO_RAW);
+                    struct sockaddr_in sin;
+                    int flag;
+
+                    /* Decrement TTL, since the raw socket will recalculate
+                     * the IP checksum, don't worry about it */
+                    ip->ttl--;
+                    flag = -1;
+                    setsockopt(sock, SOL_IP, IP_HDRINCL, &flag, sizeof(flag));
+                    /* Repeat packet */
+                    memset(&sin, 0, sizeof(sin));
+                    sin.sin_family = AF_INET;
+                    sin.sin_port = ip->protocol;
+                    sin.sin_addr.s_addr = htonl(src_addr);
+                    if(sendto(sock, pkt->payload, pkt->data_len, MSG_DONTROUTE,
+                                    (struct sockaddr*)&sin, sizeof(sin)) < 0) {
+                            perror("send_raw");
+                    }
+
+                    /* Reincrement the checksum so we don't have a bad
+                     * checksum or drop the packet. */
+                    ip->ttl++;
+                    close(sock);
+#endif /* #if 0 */
+                }
+
+                status = ipq_set_verdict( h, pkt->packet_id, NF_ACCEPT,
+                        pkt->data_len, pkt->payload);
+                if(status < 0)
+                    die(h);
+
+                /* we did our own accept! */
+                /* goto accept; */
+                return;
+            }
+            /***** never gets here... look above ****/
+        }
+    }
+#endif
+
     /* OK, the timeouts have been updated. Now see if either: 1. The
        packet is for this node -> ACCEPT. 2. The packet is not for this
        node -> Send RERR (someone want's this node to forward packets
@@ -271,6 +489,13 @@
     /* If the packet is destined for this node, then just accept it. */
     if (dest_addr == DEV_IFINDEX(ifindex).ipaddr)
 	goto accept;
+    /* If in gateway mode and packet is headed to a different subnet, see
+     * if we have a wired route for it */
+    if (this_host.gateway_mode && ((dest_addr & DEV_IFINDEX(ifindex).netmask)
+            != (DEV_IFINDEX(ifindex).ipaddr & DEV_IFINDEX(ifindex).netmask))) {
+        if(get_route_metric(htonl(dest_addr)) != -1)
+            goto accept;
+    }
 
     if (!fwd_rt || fwd_rt->state == INVALID ||
 	(fwd_rt->hcnt == 1 && (fwd_rt->flags & RT_UNIDIR))) {
@@ -290,10 +515,10 @@
 #else
 #define PACKET_IS_INBOUND pkt->hook == 0
 #endif
-	if (PACKET_IS_INBOUND) {
-
+	if (PACKET_IS_INBOUND && (pkt->mark != 4)) {
 	    u_int32_t rerr_dest;
 	    RERR *rerr;
+
 #ifdef NS_PORT
 	    DEBUG(LOG_DEBUG, 0,
 		  "No route, src=%s dest=%s prev_hop=%s - DROPPING!",
@@ -347,6 +572,10 @@
 #else
 	packet_queue_add(pkt->packet_id, dest_addr);
 
+#ifdef MAODV
+       mcast_route_discovery:
+#endif /* MAODV */
+
 	/* Already seeking the destination? Then do not allocate any
 	   memory or generate a RREQ. */
 	if (seek_list_find(dest_addr))
@@ -370,7 +599,7 @@
 	if (fwd_rt && (fwd_rt->flags & RT_REPAIR))
 	    rreq_local_repair(expired_rt, src_addr, ipd);
 	else
-	    rreq_route_discovery(dest_addr, rreq_flags, ipd);
+	    rreq_route_discovery(dest_addr, rreq_flags, ipd, 0);
 
 	return;
 
diff -urNb aodv-uu-0.7.2/packet_queue.c maodv-umd-0.7.2/packet_queue.c
--- aodv-uu-0.7.2/packet_queue.c	Tue May 27 10:41:15 2003
+++ maodv-umd-0.7.2/packet_queue.c	Wed Jun 25 17:46:10 2003
@@ -34,6 +34,10 @@
 #include "timer_queue.h"
 #include "aodv_timeout.h"
 
+#ifdef MAODV
+#include "multicast_routing_table.h"
+#endif
+
 extern struct ipq_handle *h;
 
 #endif
@@ -69,6 +73,9 @@
 #else
 	ipq_set_verdict(h, qp->id, NF_DROP, 0, NULL);
 #endif				/* NS_PORT */
+    if(qp->payload != NULL) {
+        free(qp->payload);
+    }
 	free(qp);
 	count++;
     }
@@ -96,6 +103,9 @@
 	    ipq_set_verdict(h, qp->id, NF_DROP, 0, NULL);
 #endif				/* NS_PORT */
 
+        if(qp->payload) {
+            free(qp->payload);
+        }
 	    free(qp);
 	    count++;
 	    PQ.len--;
@@ -108,6 +118,7 @@
     
     return count;
 }
+
 /* Buffer a packet in a FIFO queue. Implemented as a linked list,
    where we add elements at the end and remove at the beginning.... */
 
@@ -153,6 +164,9 @@
 #endif
     qp->dest_addr = dest_addr;
     
+    qp->payload = NULL;
+    qp->size = 0;
+
     gettimeofday(&qp->q_time, NULL);
     
     list_add_tail(&PQ.head, &qp->l);
@@ -168,6 +182,43 @@
 #endif
 }
 
+void mcast_packet_queue_add(unsigned long id, u_int32_t dest_addr,
+    u_int32_t s, u_int8_t *pay)
+{
+    struct q_pkt *qp;
+
+    if (PQ.len >= MAX_QUEUE_LENGTH) {
+    DEBUG(LOG_DEBUG, 0, "MAX Queue length reached. Removing first pkt in queue");
+    if(!list_empty(&PQ.head)) {
+        qp = (struct q_pkt *)PQ.head.next;
+
+        list_detach(PQ.head.next);
+        ipq_set_verdict(h, qp->id, NF_DROP, 0, NULL);
+        PQ.len--;
+        if ( qp->payload )
+            free( qp->payload );
+        free(qp);
+    }
+    }
+
+    if ((qp = (struct q_pkt *) malloc(sizeof(struct q_pkt))) == NULL) {
+	fprintf(stderr, "Malloc failed!\n");
+	exit(-1);
+    }
+
+    qp->id = id;
+    qp->dest_addr = dest_addr;
+
+    qp->payload = pay;
+    qp->size = s;
+
+    gettimeofday(&qp->q_time, NULL);
+    list_add_tail(&PQ.head, &qp->l);
+
+    PQ.len++;
+}
+
+
 int NS_CLASS packet_queue_drop(u_int32_t dest_addr)
 {
     int count = 0;
@@ -183,6 +234,9 @@
 #else
 	    ipq_set_verdict(h, qp->id, NF_DROP, 0, NULL);
 #endif
+        if(qp->payload != NULL) {
+            free(qp->payload);
+        }
 	    free(qp);
 	    count++;
 	    PQ.len--;
@@ -226,7 +280,9 @@
 #else
 	    ipq_set_verdict(h, qp->id, NF_ACCEPT, 0, NULL);
 #endif				/* NS_PORT */
-	   
+	    if(qp->payload) {
+            DEBUG(LOG_DEBUG, 0, "Sent a multicast queued packet from wrong function.");
+        }
 	    free(qp);
 	    count++;
 	    PQ.len--;
@@ -249,3 +305,59 @@
 
     return count;
 }
+
+#ifdef MAODV
+
+int NS_CLASS mcast_packet_queue_send(u_int32_t dest_addr)
+{
+    int count = 0;
+    list_t *pos, *tmp;
+    mrt_table_t *mrt;
+#ifdef NS_PORT
+    double delay = 0;
+#define ARP_DELAY 0.005
+#endif
+
+    mrt = mrt_table_find(dest_addr);
+
+    if (!mrt || !mrt->is_router )
+	return -1;
+   
+    list_foreach_safe(pos, tmp, &PQ.head) {
+    struct q_pkt *qp = (struct q_pkt*)pos;
+
+	if (qp->dest_addr == dest_addr) {
+        list_detach(pos);
+	    ipq_set_verdict(h, qp->id, NF_ACCEPT, qp->size, 
+                qp->payload);
+
+        if ( qp->payload ) {
+            free( qp->payload );
+        }
+	    free(qp);
+	    count++;
+	    PQ.len--;
+	}
+    }
+
+    /* Update rt timeouts */
+    if (dest_addr != DEV_IFINDEX(mrt->ifindex).ipaddr) {
+        /* TODO: CHECK: Update multicast route table timer. */
+	/* rt_table_update_timeout(rt, ACTIVE_ROUTE_TIMEOUT); */
+
+        /*
+	next_hop_rt = rt_table_find(rt->next_hop);
+
+	if (next_hop_rt && next_hop_rt->state == VALID && 
+	    next_hop_rt->dest_addr != rt->dest_addr)
+	    rt_table_update_timeout(next_hop_rt, ACTIVE_ROUTE_TIMEOUT);
+        */
+    }
+
+    DEBUG(LOG_INFO, 0, "SENT %d packets to %s qlen=%u",
+	  count, ip_to_str(dest_addr), PQ.len);
+
+    return count;
+}
+
+#endif /* MAODV */
diff -urNb aodv-uu-0.7.2/packet_queue.h maodv-umd-0.7.2/packet_queue.h
--- aodv-uu-0.7.2/packet_queue.h	Thu May 22 19:11:35 2003
+++ maodv-umd-0.7.2/packet_queue.h	Thu Jul 17 18:03:51 2003
@@ -26,7 +26,7 @@
 #include "defs.h"
 #include "list.h"
 
-#define MAX_QUEUE_LENGTH 100
+#define MAX_QUEUE_LENGTH 20
 #define MAX_QUEUE_TIME 10000 /* Maximum time packets can be queued (ms) */
 #define GARBAGE_COLLECT_TIME 1000 /* Interval between running the
 				   * garbage collector (ms) */
@@ -40,6 +40,8 @@
 #else
     unsigned long id;
 #endif
+    u_int8_t * payload;
+    u_int32_t size;
 };
 
 struct packet_queue {
@@ -58,6 +60,11 @@
 #else
 void packet_queue_add(unsigned long id, u_int32_t dest_addr);
 #endif
+
+int mcast_packet_queue_send(u_int32_t dest_addr);
+void mcast_packet_queue_add(unsigned long id, u_int32_t dest_addr,
+    u_int32_t s, u_int8_t *pay);
+
 void packet_queue_init();
 void packet_queue_destroy();
 int packet_queue_drop(u_int32_t dest_addr);
diff -urNb aodv-uu-0.7.2/params.h maodv-umd-0.7.2/params.h
--- aodv-uu-0.7.2/params.h	Mon Nov 11 11:57:21 2002
+++ maodv-umd-0.7.2/params.h	Wed Jun 25 17:46:10 2003
@@ -33,12 +33,12 @@
 #define DELETE_PERIOD           ACTIVE_ROUTE_TIMEOUT
 #else
 /* HELLO messages are used: */
-#define ACTIVE_ROUTE_TIMEOUT    3000
+#define ACTIVE_ROUTE_TIMEOUT    3500
 #define DELETE_PERIOD           K * max(ACTIVE_ROUTE_TIMEOUT, ALLOWED_HELLO_LOSS * HELLO_INTERVAL)
 #define TTL_START               2
 #endif
 
-#define ALLOWED_HELLO_LOSS      2
+#define ALLOWED_HELLO_LOSS      3
 /* If expanding ring search is used, BLACKLIST_TIMEOUT should be?: */
 #define BLACKLIST_TIMEOUT       RREQ_RETRIES * NET_TRAVERSAL_TIME + (TTL_THRESHOLD - TTL_START)/TTL_INCREMENT + 1 + RREQ_RETRIES
 #define HELLO_INTERVAL          1000
@@ -57,5 +57,10 @@
 #define TIMEOUT_BUFFER          2
 #define TTL_INCREMENT           2
 #define TTL_THRESHOLD           7
+
+/* MAODV params */
+#define GROUP_HELLO_INTERVAL    5000
+#define RREP_WAIT_TIME          10000
+#define PRUNE_TIMEOUT           2 * RREP_WAIT_TIME
 
 #endif
diff -urNb aodv-uu-0.7.2/routing_table.c maodv-umd-0.7.2/routing_table.c
--- aodv-uu-0.7.2/routing_table.c	Tue May 27 12:32:58 2003
+++ maodv-umd-0.7.2/routing_table.c	Wed Jun 25 17:46:10 2003
@@ -39,6 +39,8 @@
 #include "seek_list.h"
 #endif				/* NS_PORT */
 
+#include <assert.h>
+
 static unsigned int hashing(u_int32_t * addr, hash_value * hash);
 
 #ifndef NS_PORT
@@ -156,6 +158,8 @@
     
     rt_tbl.num_entries++;
     
+    /* trying to track weird route bug */
+    assert(!(dest_addr == DEV_NR(0).ipaddr == next));	
 
     DEBUG(LOG_INFO, 0, "Inserting %s (bucket %d) next hop %s",
 	  ip_to_str(dest_addr), index, ip_to_str(next));
diff -urNb aodv-uu-0.7.2/seek_list.c maodv-umd-0.7.2/seek_list.c
--- aodv-uu-0.7.2/seek_list.c	Thu May 22 19:11:35 2003
+++ maodv-umd-0.7.2/seek_list.c	Wed Jun 25 17:46:10 2003
@@ -47,7 +47,9 @@
 seek_list_t *NS_CLASS seek_list_insert(u_int32_t dest_addr,
 				       u_int32_t dest_seqno,
 				       int ttl, u_int8_t flags,
-				       struct ip_data *ipd)
+				       struct ip_data *ipd,
+                                       u_int16_t grp_hcnt,
+                                       u_int32_t grp_addr )
 {
     seek_list_t *entry;
 
@@ -62,6 +64,8 @@
     entry->reqs = 0;
     entry->ttl = ttl;
     entry->ipd = ipd;
+    entry->grp_hcnt = grp_hcnt;
+    entry->grp_addr = grp_addr;
     entry->seek_timer.handler = &NS_CLASS route_discovery_timeout;
     entry->seek_timer.data = entry;
 
@@ -72,6 +76,32 @@
     return entry;
 }
 
+#ifdef MAODV
+int NS_CLASS seek_list_remove_mcast(u_int32_t dest_addr, u_int32_t grp_addr)
+{
+    list_t *pos;
+
+    list_foreach(pos, &seekhead) {
+	seek_list_t *entry = (seek_list_t *)pos;
+
+	if ((entry->dest_addr == dest_addr) && (entry->grp_addr == grp_addr)) {
+    	list_detach(&entry->l);
+
+        /* Make sure any timers are removed */
+        timer_remove(&entry->seek_timer);
+
+        if (entry->ipd)
+            free(entry->ipd);
+	    
+        free(entry);
+        return 1;
+    }
+    }
+
+	return 0;
+}
+#endif
+
 int NS_CLASS seek_list_remove(seek_list_t *entry)
 {
     if (!entry)
@@ -101,6 +131,27 @@
     }
     return NULL;
 }
+
+#ifdef MAODV
+/* note: This function call seems misleading at first because
+   most of the time a multicast RREQ should be destined for
+   a group, but tree merge is destined for the leader and contains
+   the group information in an extension. */
+seek_list_t *NS_CLASS seek_list_find_mcast(u_int32_t dest_addr, 
+    u_int32_t grp_addr)
+{
+    list_t *pos;
+
+    list_foreach(pos, &seekhead) {
+	seek_list_t *entry = (seek_list_t *)pos;
+
+	if ((entry->dest_addr == dest_addr) && (entry->grp_addr == grp_addr)) {
+	    return entry;
+    }
+    }
+    return NULL;
+}
+#endif
 
 #ifdef SEEK_LIST_DEBUG
 void NS_CLASS seek_list_print()
diff -urNb aodv-uu-0.7.2/seek_list.h maodv-umd-0.7.2/seek_list.h
--- aodv-uu-0.7.2/seek_list.h	Thu May 22 19:11:35 2003
+++ maodv-umd-0.7.2/seek_list.h	Wed Jun 25 17:46:10 2003
@@ -44,15 +44,25 @@
     u_int8_t flags;		/* The flags we are using for resending the RREQ */
     int reqs;
     int ttl;
+    u_int16_t grp_hcnt;
+    u_int32_t grp_addr;
     struct timer seek_timer;
 } seek_list_t;
 #endif				/* NS_NO_GLOBALS */
 
 #ifndef NS_NO_DECLARATIONS
 seek_list_t *seek_list_insert(u_int32_t dest_addr, u_int32_t dest_seqno,
-			      int ttl, u_int8_t flags, struct ip_data *ipd);
+			      int ttl, u_int8_t flags, struct ip_data *ipd,
+                  u_int16_t grp_hcnt, u_int32_t grp_addr);
 int seek_list_remove(seek_list_t *entry);
 seek_list_t *seek_list_find(u_int32_t dest_addr);
+
+#ifdef MAODV
+seek_list_t *seek_list_find_mcast(u_int32_t dest_addr,
+    u_int32_t grp_addr);
+int NS_CLASS seek_list_remove_mcast(u_int32_t dest_addr,
+    u_int32_t grp_addr);
+#endif
 
 #ifdef NS_PORT
 #ifdef SEEK_LIST_DEBUG
